﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Runtime.Serialization.Formatters.Binary;
using System.IO;

namespace howto_serialize_images
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Add the files to a list.
            List<Image> input_images = new List<Image>();
            input_images.Add((Bitmap)picSource1.Image);
            input_images.Add((Bitmap)picSource2.Image);
            input_images.Add((Bitmap)picSource3.Image);

            // Serialize.
            byte[] bytes;
            using (MemoryStream ms = new MemoryStream())
            {
                BinaryFormatter formatter = new BinaryFormatter();
                formatter.Serialize(ms, input_images);
                bytes = ms.ToArray();
            }

            // Display the serialization bytes.
            txtHex.Text = BitConverter.ToString(
                bytes, 0).Replace('-', ' ');
            txtHex.Select(0, 0);

            // Deserialize.
            using (MemoryStream ms = new MemoryStream(bytes))
            {
                BinaryFormatter formattter = new BinaryFormatter();
                List<Image> output_images =
                    (List<Image>)formattter.Deserialize(ms);
                picDest1.Image = output_images[0];
                picDest2.Image = output_images[1];
                picDest3.Image = output_images[2];
            }
        }
    }
}
